import java.io
import java.lang
import bioformats_jar._loci.poi.hssf.record
import bioformats_jar._loci.poi.poifs.filesystem
import typing



class HSSFEventFactory:
    def __init__(self): ...
    def abortableProcessEvents(self, hSSFRequest: 'HSSFRequest', inputStream: java.io.InputStream) -> int: ...
    def abortableProcessWorkbookEvents(self, hSSFRequest: 'HSSFRequest', pOIFSFileSystem: bioformats_jar._loci.poi.poifs.filesystem.POIFSFileSystem) -> int: ...
    def processEvents(self, hSSFRequest: 'HSSFRequest', inputStream: java.io.InputStream) -> None: ...
    def processWorkbookEvents(self, hSSFRequest: 'HSSFRequest', pOIFSFileSystem: bioformats_jar._loci.poi.poifs.filesystem.POIFSFileSystem) -> None: ...

class HSSFListener:
    def processRecord(self, record: bioformats_jar._loci.poi.hssf.record.Record) -> None: ...

class HSSFRequest:
    def __init__(self): ...
    def addListener(self, hSSFListener: HSSFListener, short: int) -> None: ...
    def addListenerForAllRecords(self, hSSFListener: HSSFListener) -> None: ...

class HSSFUserException(java.lang.Exception):
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, string: typing.Union[java.lang.String, str]): ...
    @typing.overload
    def __init__(self, string: typing.Union[java.lang.String, str], throwable: java.lang.Throwable): ...
    @typing.overload
    def __init__(self, throwable: java.lang.Throwable): ...
    def getReason(self) -> java.lang.Throwable: ...

class AbortableHSSFListener(HSSFListener):
    def __init__(self): ...
    def abortableProcessRecord(self, record: bioformats_jar._loci.poi.hssf.record.Record) -> int: ...
    def processRecord(self, record: bioformats_jar._loci.poi.hssf.record.Record) -> None: ...


class __module_protocol__(typing.Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("loci.poi.hssf.eventusermodel")``.

    AbortableHSSFListener: typing.Type[AbortableHSSFListener]
    HSSFEventFactory: typing.Type[HSSFEventFactory]
    HSSFListener: typing.Type[HSSFListener]
    HSSFRequest: typing.Type[HSSFRequest]
    HSSFUserException: typing.Type[HSSFUserException]
